
import java.awt.Canvas;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Image;
import java.awt.Rectangle;
import java.awt.event.ComponentListener;
import java.util.EventListener;

import javax.swing.ImageIcon;

/**
 * A canvas which renders a smiley-face to the screen
 * 
 * Note: Canvas is a heavyweight superclass, which makes SmileyCanvas also
 * heavyweight. To convert this class to a lightweight, change "extends Canvas"
 * to "extends Component".
 * 
 * http://java.sun.com/products/jfc/tsc/articles/painting/src/PaintDemo.java
 */
public class SmileyCanvas extends Canvas {

	static int count = 0;

	public SmileyCanvas(Color faceColor) {
		this.setForeground(faceColor);

	}

	public Dimension getPreferredSize() {
		return new Dimension(300, 300);
	}

	/*
	 * Paint when the AWT tells us to...
	 */
	public void paint(Graphics g) {
		count++;
		// Dynamically calculate size information
		// (the canvas may have been resized externally...)
		Dimension size = getSize();
		
		//Rectangle myArea = g.getClipBounds();
		this.setForeground(Color.RED);
		Graphics2D g2 = (Graphics2D) this.getGraphics();
		//System.out.println(g.equals(g2));


		int d = Math.min(size.width, size.height); // diameter
		int ed = d / 20; // eye diameter
		int x = (size.width - d) / 2;
		int y = (size.height - d) / 2;

		// draw head (color already set to foreground)
		g.fillOval(x, y, d, d);
		g.setColor(Color.black);
		g.drawOval(x, y, d, d);

		// draw eyes
		g.fillOval(x + d / 3 - (ed / 2), y + d / 3 - (ed / 2), ed, ed);
		g.fillOval(x + (2 * (d / 3)) - (ed / 2), y + d / 3 - (ed / 2), ed, ed);

		// draw mouth
		g.drawArc(x + d / 4, y + 2 * (d / 5), d / 2, d / 3, 0, -180);
		System.out.print("count: " + count);
		System.out.println();

	}

}
